import java.util.LinkedList;
import java.util.Queue;

/**
 * Esta classe contem uma fila de Notas MIDI que serao executadas uma depois de outra.
 * Esta baseado no problema clssico do produtor-cosumidor, neste caso o produtor  o
 * Sonorizador e o consumidor o Executor.
 *
 */
public class Executor extends Thread {
	MIDI midi;
	private Queue<MIDI.Note> queue;
	int instrument = 0;

	public Executor() {
		midi = new MIDI();
		midi.open();
		queue = new LinkedList<MIDI.Note>();
	}

	public void addNote(int pitch, int duration, int velocity) {
		queue.add(midi.createNote(pitch, duration, velocity));
		// notify();
	}

	@Override
	public void run() {
		while (true) {
			//Caso for que a fila estiver vazia, dorme 250 ms e logo pergunta de novo
			if (queue.isEmpty()) {
				try {
					sleep(250);
				} catch (InterruptedException e) {
					e.printStackTrace();
				}
				continue;
			}

			//Pega a seguinte nota da fila
			MIDI.Note note = queue.poll();
			note.instrument = instrument;
			//Toca a nota
			midi.playNote(note);
			//System.out.println(instrument + "->" + queue.size());
			try {
				sleep(note.duration);//Espera que a nota seja tocada
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
		}
	}
}
